如何使用JUnit Test注释声明我的异常消息?

2020/10/26 01:11 · java ·  · 0评论

我写了一些带有@Test注释的JUnit测试如果我的测试方法引发了一个已检查的异常,并且我想与异常一起声明该消息,是否可以使用JUnit@Test注释来做到这一点AFAIK,JUnit 4.7不提供此功能,但是将来的版本会提供吗?我知道在.NET中,您可以断言消息和异常类。在Java世界中寻找类似的功能。

这就是我要的:

@Test (expected = RuntimeException.class, message = "Employee ID is null")
public void shouldThrowRuntimeExceptionWhenEmployeeIDisNull() {}

您可以将@Rule注释与一起使用ExpectedException,如下所示:

@Rule
public ExpectedException expectedEx = ExpectedException.none();

@Test
public void shouldThrowRuntimeExceptionWhenEmployeeIDisNull() throws Exception {
    expectedEx.expect(RuntimeException.class);
    expectedEx.expectMessage("Employee ID is null");

    // do something that should throw the exception...
    System.out.println("=======Starting Exception process=======");
    throw new NullPointerException("Employee ID is null");
}

请注意,ExpectedException文档中的示例(当前)是错误的-没有公共构造函数,因此您必须使用ExpectedException.none()

我喜欢@Rule答案。但是,如果由于某种原因您不想使用规则。还有第三种选择。

@Test (expected = RuntimeException.class)
public void myTestMethod()
{
   try
   {
      //Run exception throwing operation here
   }
   catch(RuntimeException re)
   {
      String message = "Employee ID is null";
      assertEquals(message, re.getMessage());
      throw re;
    }
    fail("Employee Id Null exception did not throw!");
  }

在JUnit 4.13中,您可以执行以下操作:

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertThrows;

...

@Test
void exceptionTesting() {
  IllegalArgumentException exception = assertThrows(
    IllegalArgumentException.class, 
    () -> { throw new IllegalArgumentException("a message"); }
  );

  assertEquals("a message", exception.getMessage());
}

这在JUnit 5中也可以使用,但导入方式不同:

import static org.junit.jupiter.api.Assertions.assertEquals;
import static org.junit.jupiter.api.Assertions.assertThrows;

...

你要用@Test(expected=SomeException.class)吗?当我们必须断言异常的实际消息时,这就是我们要做的。

@Test
public void myTestMethod()
{
  try
  {
    final Integer employeeId = null;
    new Employee(employeeId);
    fail("Should have thrown SomeException but did not!");
  }
  catch( final SomeException e )
  {
    final String msg = "Employee ID is null";
    assertEquals(msg, e.getMessage());
  }
}

实际上,最好的用法是使用try / catch。为什么?因为您可以控制发生异常的位置。

考虑以下示例:

@Test (expected = RuntimeException.class)
public void someTest() {
   // test preparation
   // actual test
}

如果有一天代码被修改并且测试准备会抛出RuntimeException怎么办?在那种情况下,实际测试甚至不会被测试,即使它没有引发任何异常,测试也将通过。

这就是为什么使用try / catch比依赖注释要好得多的原因。

雷暴有一个很好的答案。我也不是规则的忠实拥护者。除了创建以下实用程序类以帮助提高可读性和可用性外,我执行了类似的操作,这首先是批注的一大优点。

添加此实用程序类:

import org.junit.Assert;

public abstract class ExpectedRuntimeExceptionAsserter {

    private String expectedExceptionMessage;

    public ExpectedRuntimeExceptionAsserter(String expectedExceptionMessage) {
        this.expectedExceptionMessage = expectedExceptionMessage;
    }

    public final void run(){
        try{
            expectException();
            Assert.fail(String.format("Expected a RuntimeException '%s'", expectedExceptionMessage));
        } catch (RuntimeException e){
            Assert.assertEquals("RuntimeException caught, but unexpected message", expectedExceptionMessage, e.getMessage());
        }
    }

    protected abstract void expectException();

}

然后对于我的单元测试,我只需要这段代码:

@Test
public void verifyAnonymousUserCantAccessPrivilegedResourceTest(){
    new ExpectedRuntimeExceptionAsserter("anonymous user can't access privileged resource"){
        @Override
        protected void expectException() {
            throw new RuntimeException("anonymous user can't access privileged resource");
        }
    }.run(); //passes test; expected exception is caught, and this @Test returns normally as "Passed"
}

我从不喜欢用Junit声明异常的方式。如果在批注中使用“期望”,则从我的角度来看,我们似乎违反了“给定,何时,那么”模式,因为“则”位于测试定义的顶部。

另外,如果使用“ @Rule”,则必须处理大量样板代码。因此,如果您可以为测试安装新的库,建议您看一下AssertJ(该库现在随SpringBoot一起提供)

然后进行不违反“给定/何时/然后”原则的测试,并使用AssertJ进行验证以验证:

1-例外是我们所期望的。2-也有预期的消息

将如下所示:

 @Test
void should_throwIllegalUse_when_idNotGiven() {

    //when
    final Throwable raisedException = catchThrowable(() -> getUserDAO.byId(null));

    //then
    assertThat(raisedException).isInstanceOf(IllegalArgumentException.class)
            .hasMessageContaining("Id to fetch is mandatory");
}

如果使用@Rule,则将异常集应用于Test类中的所有测试方法。

我喜欢user64141的答案,但发现它可以更一般化。这是我的看法:

public abstract class ExpectedThrowableAsserter implements Runnable {

    private final Class<? extends Throwable> throwableClass;
    private final String expectedExceptionMessage;

    protected ExpectedThrowableAsserter(Class<? extends Throwable> throwableClass, String expectedExceptionMessage) {
        this.throwableClass = throwableClass;
        this.expectedExceptionMessage = expectedExceptionMessage;
    }

    public final void run() {
        try {
            expectException();
        } catch (Throwable e) {
            assertTrue(String.format("Caught unexpected %s", e.getClass().getSimpleName()), throwableClass.isInstance(e));
            assertEquals(String.format("%s caught, but unexpected message", throwableClass.getSimpleName()), expectedExceptionMessage, e.getMessage());
            return;
        }
        fail(String.format("Expected %s, but no exception was thrown.", throwableClass.getSimpleName()));
    }

    protected abstract void expectException();

}

请注意,将“ fail”语句保留在try块内会导致捕获相关的断言异常。在catch语句中使用return可以防止这种情况。

导入catch-exception库,并使用它。它比ExpectedException规则或规则干净得多try-catch

以他们的文档为例:

import static com.googlecode.catchexception.CatchException.*;
import static com.googlecode.catchexception.apis.CatchExceptionHamcrestMatchers.*;

// given: an empty list
List myList = new ArrayList();

// when: we try to get the first element of the list
catchException(myList).get(1);

// then: we expect an IndexOutOfBoundsException with message "Index: 1, Size: 0"
assertThat(caughtException(),
  allOf(
    instanceOf(IndexOutOfBoundsException.class),
    hasMessage("Index: 1, Size: 0"),
    hasNoCause()
  )
);
@Test (expectedExceptions = ValidationException.class, expectedExceptionsMessageRegExp = "This is not allowed")
public void testInvalidValidation() throws Exception{
     //test code
}
本文地址:http://java.askforanswer.com/ruheshiyongjunit-testzhushishengmingwodeyichangxiaoxi-2.html
文章标签: ,   ,   ,   ,  
版权声明:本文为原创文章,版权归 admin 所有,欢迎分享本文,转载请保留出处!

文件下载

老薛主机终身7折优惠码boke112

上一篇:
下一篇:

评论已关闭!